
--max2nuke r06 _clipboard
--multiple objects can be copied to the clipboard and pasted on the nuke dag. so far, everything that is not a camera simply becomes an axis in nuke
--transform order is set automatically
--the nodes are labelled with their max scene names (whitespaces are removed)
--vray cams work
--this  macrosript is meant to be used with a hotkey and has no gui or options

macroScript max2nuke_clipboard 
category:"Mondochiba"
(

	fn camfov cam = (if classOf cam == VRayPhysicalCamera then (
		cam.focal_length*(1+(cam.focal_length/10)/((if cam.specify_focus==true then cam.focus_distance else cam.target_distance)-cam.focal_length/10)))
		else (cameraFOV.FOVtoMM cam.fov))	
	fn rotationoffset obj = (if superclassof obj == camera then ((quatToEuler obj.objectoffsetrot).x-90) else 0)
	fn hap obj =(if classOf obj == VRayPhysicalCamera then (obj.film_width) else GetRendApertureWidth())
	fn vap obj = (if classOf obj == VRayPhysicalCamera then (obj.film_width/GetRendImageAspect()) 
	else ((GetRendApertureWidth()/GetRendImageAspect()) as string))
	fn focusdistance obj = (if classOf obj == VRayPhysicalCamera then (if obj.specify_focus==true then obj.focus_distance else obj.target_distance) 
	else (if classof obj == Targetcamera then obj.targetdistance else obj.target_Distance))		
	fn nodename obj = (if superclassof obj == camera then "Camera" else "Axis") 	
		
	if selection[1] != undefined then	
	
	(
		
		clipboardstring=""
		
		for obj in selection do
			
		(
			streamname=obj.name as stringstream
			labelname=""
			(while peekToken streamname != undefined do labelname += (readToken streamname))	
			
			transcurvex=""
			transcurvey=""
			transcurvez=""
			rotationcurvex=""
			rotationcurvey=""
			rotationcurvez=""
			scalecurvex=""
			scalecurvey=""
			scalecurvez=""
			focalcurve=""	
			zoomcurve=""
			focuscurve=""
				
				
		for t in animationrange.start to animationrange.end do 

			(

				at time t
					
				(	
		
					transcurvex += (obj.transform.position.x) as string +" "
					transcurvey += (obj.transform.position.z) as string +" "
					transcurvez += (obj.transform.position.y*-1) as string +" "
					
					rotationcurvex +=((quatToEuler obj.transform.rotation).x + (rotationoffset obj)) as string +" "
					rotationcurvey += ((quatToEuler obj.transform.rotation).z) as string +" "
					rotationcurvez += ((quatToEuler obj.transform.rotation).y*-1) as string +" "
					
					if superclassof obj == camera then (
						
					focalcurve +=(camfov obj) as string +" "
					zoomcurve += (if classOf obj == VRayPhysicalCamera then  (1/obj.zoom_factor) else (1)) as string +" "
					focuscurve += (focusdistance obj) as string + " "
						
					)
					
					else
					(
					scalecurvex +=	(obj.transform.scale.x) as string +" "
					scalecurvey +=	(obj.transform.scale.z) as string +" "
					scalecurvez +=	(obj.transform.scale.y) as string +" "
					)	
						
				)	
	
			)
			
			clipboardstring += (nodename obj +" {\ninputs 0\nselectable false\nrot_order XZY\n")
			clipboardstring +=  ("translate {{curve i "+ transcurvex +"} {curve i "+transcurvey+"} {curve i "+transcurvez+"}}\n")
			clipboardstring += ("rotate {{curve i "+rotationcurvex+"} {curve i "+rotationcurvey+"} {curve i "+rotationcurvez+"}}\n")
			clipboardstring += ((if superclassof obj == camera then ("focal {{curve i "+focalcurve+"}}\n") 
										else ("scaling {{curve i "+ scalecurvex +"} {curve i "+scalecurvey+"} {curve i "+scalecurvez+"}}\n")))
			clipboardstring += (if superclassof obj == camera then ("haperture "+((hap obj) as string)+"\nvaperture "+((vap obj) as string)+"\n") else "")
			clipboardstring +=(if classOf obj == VRayPhysicalCamera then ("win_scale {{curve i "+zoomcurve+"} {curve i "+zoomcurve+"}} \n") else "")
			clipboardstring +=(if superclassOf obj == camera then ( "focal_point {{curve i "+focuscurve+"}}\n") else "")
			clipboardstring +=  ("label 3dsMax_"+labelname+"\nname " + (nodename obj))
			clipboardstring += "\n}\n"
			
				
		)
			
			SetClipBoardText (clipboardstring as string)
		)


)
