--max2nuke chanfile and obj exporter v.06 christian pundschus (mondochiba) suki@gmx.net
--exports a chanfile with animation data from 3dsmax to be loaded into a nuke cameras, axis or transform-geos
--exports object sequences

--you need to replace (make a backup!) the "import_chan_file.tcl" in the nuke plugin folder with
--the one in this zip, it adds support for importing the aperture settings (thanks to frank rueter for the tcl hint)

--transform and rotation order in nuke: SRT and XZY
	
--version history:
	
--v.01: initial release
	
--v.02:  the provided import_chan_file is now compatible with other chanfiles
---if there are haperture and vaperture values present in the chanfile, nuke uses these to calculate the focal length

--v.03  fixed a bug that led to wrong data when camera rolled
---helpers and objects are now also supported (remember to export obj at the first frame of your animation)
---added checkbox to avoid chanfile pop-up
---the rotation order is now XZY!
---script is now a macroscript (category:Mondochiba)

--v.04	-added export of obj sequences (for nuke 4.8 and higher // load into readgeo as sequence) so you can bring objects with vertex animation to nuke
--(this can also be multiple objects in one obj)
---added export of single obj files (same as using the normal max export but with fewer mouse-clicks, obj is alway exported at start-spinner frame)
---added a framerange override (click R to reset)
---added a progressbar
---put the transform and rotation orders as text in the gui as a reminder  

--v.05  added import of chanfiles from nuke cameras or axis,geos,cards etc.
---multiple objects can now be copied to the clipboard and pasted on the nuke dag. so far, everything that is not a camera simply becomes an axis in nuke
--rotation order is set automatically when copy/paste is used, pasted objects are labeled according to their max scene-name
---the copy-to-clipboard comes as a seperate macroscript (max2nuke_clipboard) so you can assign a hotkey and copy/paste cameras/axis without opening a GUI 
--(eg. I use alt+ctrl+c)
---supports vray cameras  (but lacks conversion zoom and focal distance, this leads to alignment issues, solved in the next version, i hope)
-- -the window is now dockable

--v.06 fixed a typo that messed up the vray camera aperture settings
---vray focal data is now correctly recalculated based on focus distance ( focal length in nuke differs from the value you see on your max cam but
--images will line up.
--zoom and focal point are also exported


macroScript max2nuke
category: "Mondochiba"
(
	
rollout max2nuke "Max2Nuke v.06" width:140 height:585
(
	local start=animationRange.start
	local end=animationRange.end
	fn cam_filt obj =  superClassOf obj == camera
	fn point_filt obj =  superClassOf obj == helper
	fn geo_filt obj =  superClassOf obj == geometryclass	
		
	pickbutton pickcam "Pick Camera" pos:[19,30] width:102 height:27 filter:cam_filt
	pickbutton pickthepoint "Pick Point" pos:[19,62] width:102 height:27 filter:point_filt
	pickbutton pickobj "Pick Object" pos:[19,94] width:102 height:27 filter:geo_filt
	checkbox checkshow "Show Chanfile" pos:[22,132] width:100 height:15 checked:true
	button objsingle "Single Obj" pos:[19,385] width:102 height:27
	button objsequence "Obj Sequence" pos:[19,417] width:102 height:21 hyeight:27 	
	GroupBox grp1 "Write Chanfile" pos:[11,8] width:118 height:174
	GroupBox grp3 "Write Obj" pos:[9,363] width:121 height:92
	label order "SRT  XZY" pos:[46,156] width:52 height:18
	progressBar pgbar "ProgressBar" pos:[19,540] width:102 height:15 
	spinner startFrame "Start " pos:[30,486] width:65 height:16 range:[0,9999,0] type:#integer scale:1 
	spinner endFrame "End  " pos:[30,508] width:65 height:16 range:[0,9999,100] type:#integer scale:1
	GroupBox grp4 "Frame Range" pos:[9,465] width:121 height:105
	button r1 "R" pos:[106,486] width:16 height:16
	button r2 "R" pos:[106,508] width:16 height:16
	button readcam "Camera" pos:[19,215] width:102 height:27
	button readaxis "Axis" pos:[19,247] width:102 height:27
	GroupBox grp2 "Read Chanfile" pos:[9,193] width:121 height:92
	GroupBox grp9 "Clipboard" pos:[9,295] width:121 height:59
	button copy_cb "Copy" pos:[18,316] width:102 height:27
	
	
	fn camfov cam = (
	if classOf cam == VRayPhysicalCamera then  
	(
		newfocal=(cam.focal_length*(1+(cam.focal_length/10)/((if cam.specify_focus==true then cam.focus_distance else cam.target_distance)-cam.focal_length/10)))
		(2*atan (0.5*cam.film_width/GetRendImageAspect() / newfocal))
	)
	else (2*atan (0.5*GetRendApertureWidth()/GetRendImageAspect() / (cameraFOV.FOVtoMM cam.fov))))

	fn hap cam = if classOf cam == VRayPhysicalCamera then cam.film_width else (GetRendApertureWidth())

	fn vap cam = (if classOf cam == VRayPhysicalCamera then (cam.film_width/GetRendImageAspect()) 
	else (GetRendApertureWidth()/GetRendImageAspect()))
	
	on pickcam picked obj do
	(
		
		cam=obj
		file = getSaveFileName caption:"Chanfile Output" types:"Chanfile (*.chan)|*.chan|All Files (*.*)|*.*|"
		
		if file != undefined then			  
		(
			local chanfile = createFile file
					
			for t in startframe.value to endframe.value do
			(
				at time t 
	
				format "%  %  %  %  %  %  %  %  %  %\n" \
				(t as integer) \
				cam.transform.pos.x \
				cam.transform.pos.z \
				(cam.transform.pos.y*-1) \
				(((quatToEuler cam.transform.rotation).x + (quatToEuler cam.objectoffsetrot).x)-90) \
				((quatToEuler cam.transform.rotation).z) \
				((quatToEuler cam.transform.rotation).y*-1) \
				(camfov cam) (hap cam) (vap cam) \					
				to:chanfile
				
				pgbar.value=100*t/(endframe.value-startframe.value)
				
			)
			
			pgbar.value=0
			close chanfile; if checkshow.state == true do edit file
					
		)
	)
	on pickthepoint picked obj do
	(	
		local pnt=obj,
		file = getSaveFileName caption:"Chanfile Output" types:"Chanfile (*.chan)|*.chan|All Files (*.*)|*.*|"
				
		if file != undefined then
		(
			local chanfile = createFile file	  
						
			for t in startframe.value to endframe.value do
			(
				at time t 
				
				format "%  %  %  %  %  %  %\n" \
				(t as integer) \
				pnt.transform.pos.x \
				pnt.transform.pos.z \
				(pnt.transform.pos.y*-1) \
				((quatToEuler pnt.transform.rotation).x) \
				((quatToEuler pnt.transform.rotation).z) \
				((quatToEuler pnt.transform.rotation).y*-1) \				
				to:chanfile
				
				pgbar.value=100*t/(endframe.value-startframe.value)
			)
			
			pgbar.value=0	
			close chanfile; if checkshow.state == true do edit file
	
		)	
	)
	on pickobj picked obj do
	(	
		local geo=obj,
		offset=point size:0 axistripod:off centermarker:off,
		file = getSaveFileName caption:"Chanfile Output" types:"Chanfile (*.chan)|*.chan|All Files (*.*)|*.*|"
		sliderTime=animationRange.start; offset.parent=geo
					  
		if file != undefined then
		(
			local chanfile = createFile file	 		
					
			for t in startframe.value to endframe.value do
			(
				at time t 
	
				format "%  %  %  %  %  %  %\n" \
				(t as integer) \
				(offset.transform.pos.x) \
				(offset.transform.pos.z) \
				(offset.transform.pos.y*-1) \
				((quatToEuler offset.transform.rotation).x) \
				((quatToEuler offset.transform.rotation).z) \
				((quatToEuler offset.transform.rotation).y*-1) \				
				to:chanfile
				
				pgbar.value=100*t/(endframe.value-startframe.value)
				
			)
			
			pgbar.value=0
			delete offset
			close chanfile; if checkshow.state == true do edit file
	
		)
	)
	
	on objsingle pressed do
	(	
		selobj=selectByName title: "Select single or multiple objects" Filter:geo_filt; 
						
		if selobj !=undefined do
		(
			local objfile = getSaveFileName caption:"Write Obj" types:"obj (*.obj)|*.obj|All Files (*.*)|*.*|"
			
			if objfile != undefined then
			(
				if doesFileExist objfile == true then deletefile objfile
				select selobj; cf=sliderTime
				sliderTime=startframe.value			 
				exportFile objfile selectedOnly:true
				sliderTime=cf
				deselect $
			)
							
		)
	)
	on objsequence pressed do
	(
		selobj=selectByName title: "Select single or multiple objects" Filter:geo_filt
				
		if selobj !=undefined do
		(
			local framecount=substring ((10000+animationRange.start) as string) 2 5
			local objfile = getSaveFileName caption:"Obj-Sequence" types:"obj (*.obj)|*.obj|All Files (*.*)|*.*|"
						
			if objfile != undefined then				
			(
				if doesFileExist objfile == true then deletefile objfile
				cf=sliderTime; disableSceneRedraw()
				sliderTime= startframe.value; select selobj
				exportFile ((getFilenamePath objfile) + (getFilenameFile objfile)+ "." + (framecount as string) +".obj") selectedOnly:true  
			
				for t in (startframe.value+1) to endframe.value do					
				(			
					sliderTime=t 
					framecount=substring ((10000+t) as string) 2 5
					exportFile ((getFilenamePath objfile) + (getFilenameFile objfile)+ "." + (framecount as string) +".obj") #noPrompt selectedOnly:true
					
					pgbar.value=100*t/(endframe.value-startframe.value)
				)
	
				deselect $
				pgbar.value=0
				sliderTime=cf;enableSceneRedraw()
			)
		)
	)
	on r1 pressed do
		startframe.value=animationRange.startstartframe.value=animationRange.start
	on r2 pressed do
		endframe.value=animationRange.endendframe.value=animationRange.end
	
	on readcam pressed do
	(
			
			theCam=Freecamera () 
			theCam.wireColor=(color 0 50 150)
			theCam.rotation=eulerAngles -90 0 0 
			ResetTransform theCam
			theCam.name=uniqueName "Camera_chan "
			theCam.fovType=2
			
			filename=getOpenFileName caption:"Import Chanfile"  types:"Chanfile (*.chan)|*.chan|All Files (*.*)|*.*|"
			
			if filename !=undefined then
				
			(
				filedata = openfile filename
				while not eof filedata do 
				(
				
				theLine=readLine filedata as stringstream
				t=readValue theLine
				
				with animate on 
				(
						
						at time t
							
						(	
						
							theCam.pos.x=readValue theLine
							theCam.pos.z=readValue theLine
							theCam.pos.y=(readValue theLine)*-1
								
							theCam.rotation.controller.x_rotation=readValue theLine
							theCam.rotation.controller.z_rotation=readValue theLine
							theCam.rotation.controller.y_rotation=(readValue theLine)*-1
	
							theCam.curFOV= (readValue theLine)
							
						)
					)
				)
				
			close filedata
				
			)
			
			
		
	)
	on readaxis pressed do
	(
			
			thePoint=point box:true constantscreensize:on
			thePoint.name=uniqueName "Point_chan "
			filename=getOpenFileName caption:"Import Chanfile"  types:"Chanfile (*.chan)|*.chan|All Files (*.*)|*.*|"
			
			if filename !=undefined then
				
			(
				filedata = openfile filename
				while not eof filedata do 
				(
				
				theLine=readLine filedata as stringstream
				t=readValue theLine
				
				with animate on 
				(
						
						at time t
							
						(	
						
							thePoint.pos.x=readValue theLine
							thePoint.pos.z=readValue theLine
							thePoint.pos.y=(readValue theLine)*-1
								
							thePoint.rotation.controller.x_rotation=readValue theLine
							thePoint.rotation.controller.z_rotation=readValue theLine
							thePoint.rotation.controller.y_rotation=(readValue theLine)*-1
							
						)
					)
				)
				
			close filedata
				
			)
			
			
		
	)
	on copy_cb pressed do
		
(

	fn camfov cam = (if classOf cam == VRayPhysicalCamera then (
		cam.focal_length*(1+(cam.focal_length/10)/((if cam.specify_focus==true then cam.focus_distance else cam.target_distance)-cam.focal_length/10)))
		else (cameraFOV.FOVtoMM cam.fov))	
	fn rotationoffset obj = (if superclassof obj == camera then ((quatToEuler obj.objectoffsetrot).x-90) else 0)
	fn hap obj =(if classOf obj == VRayPhysicalCamera then (obj.film_width) else GetRendApertureWidth())
	fn vap obj = (if classOf obj == VRayPhysicalCamera then (obj.film_width/GetRendImageAspect()) 
	else ((GetRendApertureWidth()/GetRendImageAspect()) as string))
	fn focusdistance obj = (if classOf obj == VRayPhysicalCamera then (if obj.specify_focus==true then obj.focus_distance else obj.target_distance) 
	else (if classof obj == Targetcamera then obj.targetdistance else obj.target_Distance))		
	fn nodename obj = (if superclassof obj == camera then "Camera" else "Axis") 	
		
	if selection[1] != undefined then	
	
	(
		
		clipboardstring=""
		countloop=0	
		
		for obj in selection do
			
		(
			
			countloop+=1
			
			streamname=obj.name as stringstream
			labelname=""
			(while peekToken streamname != undefined do labelname += (readToken streamname))	
			
			transcurvex=""
			transcurvey=""
			transcurvez=""
			rotationcurvex=""
			rotationcurvey=""
			rotationcurvez=""
			scalecurvex=""
			scalecurvey=""
			scalecurvez=""
			focalcurve=""	
			zoomcurve=""
			focuscurve=""
				
			pgbar.value=100*countloop/selection.count
				
		for t in animationrange.start to animationrange.end do 

			(

				at time t
					
				(	
		
					transcurvex += (obj.transform.position.x) as string +" "
					transcurvey += (obj.transform.position.z) as string +" "
					transcurvez += (obj.transform.position.y*-1) as string +" "
					
					rotationcurvex +=((quatToEuler obj.transform.rotation).x + (rotationoffset obj)) as string +" "
					rotationcurvey += ((quatToEuler obj.transform.rotation).z) as string +" "
					rotationcurvez += ((quatToEuler obj.transform.rotation).y*-1) as string +" "
					
					if superclassof obj == camera then (
						
					focalcurve +=(camfov obj) as string +" "
					zoomcurve += (if classOf obj == VRayPhysicalCamera then  (1/obj.zoom_factor) else (1)) as string +" "
					focuscurve += (focusdistance obj) as string + " "
						
					)
					
					else
					(
					scalecurvex +=	(obj.transform.scale.x) as string +" "
					scalecurvey +=	(obj.transform.scale.z) as string +" "
					scalecurvez +=	(obj.transform.scale.y) as string +" "
					)	
						
				)	
	
			)
			
			clipboardstring += (nodename obj +" {\ninputs 0\nselectable false\nrot_order XZY\n")
			clipboardstring +=  ("translate {{curve i "+ transcurvex +"} {curve i "+transcurvey+"} {curve i "+transcurvez+"}}\n")
			clipboardstring += ("rotate {{curve i "+rotationcurvex+"} {curve i "+rotationcurvey+"} {curve i "+rotationcurvez+"}}\n")
			clipboardstring += ((if superclassof obj == camera then ("focal {{curve i "+focalcurve+"}}\n") 
										else ("scaling {{curve i "+ scalecurvex +"} {curve i "+scalecurvey+"} {curve i "+scalecurvez+"}}\n")))
			clipboardstring += (if superclassof obj == camera then ("haperture "+((hap obj) as string)+"\nvaperture "+((vap obj) as string)+"\n") else "")
			clipboardstring +=(if classOf obj == VRayPhysicalCamera then ("win_scale {{curve i "+zoomcurve+"} {curve i "+zoomcurve+"}} \n") else "")
			clipboardstring +=(if superclassOf obj == camera then ( "focal_point {{curve i "+focuscurve+"}}\n") else "")
			clipboardstring +=  ("label 3dsMax_"+labelname+"\nname " + (nodename obj))
			clipboardstring += "\n}\n"
			
				
		)
			
			SetClipBoardText (clipboardstring as string)
		)
		
		pgbar.value=0

)
)
	
createDialog max2nuke pos:[200,200]
cui.RegisterDialogBar max2nuke style:#(#cui_dock_vert,#cui_floatable,#cui_handles) 

)